/*
 * n01_sheet
 *
 * n01_sheet.c
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "..\n01_plugin.h"
#include "game_history.h"
#include "Message.h"

#include "resource.h"

/* Define */
#define CSV_FILE					TEXT("n01_sheet.csv")
#define XLS_FILE					TEXT("n01_sheet.xls")

/* Global Variables */
HINSTANCE hInst;
TCHAR csv_path[MAX_PATH];
TCHAR xls_path[MAX_PATH];

/* Local Function Prototypes */

/*
 * DllMain - C
 */
int WINAPI DllMain(HINSTANCE hInstance, DWORD fdwReason, PVOID pvReserved)
{
	TCHAR work_path[MAX_PATH];
	TCHAR *p, *r;

	switch (fdwReason) {
	case DLL_PROCESS_ATTACH:
		hInst = hInstance;
		// AvP[ṼpX擾
		GetModuleFileName(hInst, work_path, MAX_PATH - 1);
		for (p = r = work_path; *p != TEXT('\0'); p++) {
#ifndef UNICODE
			if (IsDBCSLeadByte((BYTE)*p) == TRUE) {
				p++;
				continue;
			}
#endif	// UNICODE
			if (*p == TEXT('\\') || *p == TEXT('/')) {
				r = p;
			}
		}
		*r = TEXT('\0');
		// inipX쐬
		wsprintf(csv_path, TEXT("%s\\%s"), work_path, CSV_FILE);
		wsprintf(xls_path, TEXT("%s\\%s"), work_path, XLS_FILE);
		break;

	case DLL_PROCESS_DETACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	}
	return TRUE;
}

/*
 * get_plugin_info - vOC擾
 */
__declspec(dllexport) BOOL CALLBACK get_plugin_info(const HWND hWnd, const int index, PLUGIN_GET_INFO *pgi)
{
	switch (index) {
	case 0:
		lstrcpy(pgi->title, message_get_res(IDS_STRING_PLUGIN_TITLE));
		lstrcpy(pgi->func_name, TEXT("n01_sheet"));
		lstrcpy(pgi->cmd_line, TEXT(""));
		return TRUE;
	}
	return FALSE;
}

/*
 * n01_sheet_initialize - vOC̏
 */
__declspec(dllexport) BOOL CALLBACK n01_sheet_initialize(const HWND hWnd, PLUGIN_EXEC_INFO *pei)
{
	return CALLTYPE_MENU;
}

/*
 * n01_sheet
 */
__declspec(dllexport) int CALLBACK n01_sheet(const HWND hWnd, const int call_type, PLUGIN_EXEC_INFO *pei, int param)
{
	SCORE_HISTORY *sh;

	// 擾
	sh = (SCORE_HISTORY *)SendMessage(hWnd, WM_N01_GET_SCORE_HISTORY, 0, 0);
	if (sh == NULL) {
		return PLUGIN_ERROR;
	}
	// Q[ꗗ̕\
	show_game_history(hInst, hWnd, sh);
	return PLUGIN_SUCCEED;
}
/* End of source */
